Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/Makefile	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -255,5 +255,5 @@
 CLEANS := $(addsuffix .clean,$(DIRS) $(LIBS) $(BASE_LIBS))
 
-.PHONY: all $(BASE_BUILDS) $(BUILDS) $(BUILDS_TESTS) $(CLEANS) clean export
+.PHONY: all $(BASE_BUILDS) $(BUILDS) $(BUILDS_TESTS) $(CLEANS) clean
 
 all: $(BUILDS) $(BUILDS_TESTS)
@@ -261,7 +261,4 @@
 $(BUILDS_TESTS): $(BASE_BUILDS) $(BUILDS)
 	$(MAKE) -r -C $(basename $@) all-test PRECHECK=$(PRECHECK)
-
-export: lib/posix.build lib/math.build lib/clui.build
-	$(MAKE) -r -C lib/posix export EXPORT_DIR=$(EXPORT_DIR)
 
 clean: $(CLEANS)
Index: uspace/Makefile.common
===================================================================
--- uspace/Makefile.common	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/Makefile.common	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -174,55 +174,29 @@
 endif
 
-# Flags that are not necessary, and can be overriden, but are used by default.
-DEFAULT_CFLAGS = \
-	-O$(OPTIMIZATION) \
-	-ffunction-sections \
-	-pipe \
-	-Wall \
-	-Wextra \
-	-Wno-unused-parameter \
-	-Wmissing-prototypes \
-	-Wwrite-strings \
-	-Werror-implicit-function-declaration
+COMMON_CFLAGS = $(INCLUDES_FLAGS) -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
+	-ffreestanding -fno-builtin -nostdlib -nostdinc -fexec-charset=UTF-8 \
+	-finput-charset=UTF-8 -D__$(ENDIANESS)__ -fno-common \
+	-fdebug-prefix-map=$(realpath $(ROOT_PATH))=.
+
+GCC_CFLAGS = -ffunction-sections -Wall -Wextra -Wno-clobbered \
+	-Wno-unused-parameter -Wmissing-prototypes -std=gnu99 \
+	-Werror-implicit-function-declaration \
+	-Wwrite-strings -pipe
+
+# -Wno-missing-prototypes is there because it warns about main().
+# This should be fixed elsewhere.
+CLANG_CFLAGS = -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers -Wno-typedef-redefinition \
+	-Wno-missing-prototypes -Wno-unused-command-line-argument \
+	-std=gnu99 -Werror-implicit-function-declaration -Wwrite-strings \
+	-pipe -fno-stack-protector -fno-PIC
 
 ifeq ($(CONFIG_DEBUG),y)
-	DEFAULT_CFLAGS += -Werror
-endif
-
-ifeq ($(COMPILER),clang)
-	DEFAULT_CFLAGS += \
-		-Wno-missing-field-initializers \
-		-Wno-typedef-redefinition \
-		-Wno-unused-command-line-argument
-else
-	DEFAULT_CFLAGS += \
-		-Wno-clobbered
+	COMMON_CFLAGS += -Werror
 endif
 
 ifeq ($(CONFIG_LINE_DEBUG),y)
-	DEFAULT_CFLAGS += -ggdb
-endif
-
-# Flags that should always be used, even for third-party software.
-COMMON_CFLAGS = \
-	-ffreestanding \
-	-nostdlib \
-	-nostdinc \
-	-D__$(ENDIANESS)__
-
-# Flags that are always used for HelenOS code, but not for third-party.
-HELENOS_CFLAGS = \
-	-std=gnu99 \
-	$(INCLUDES_FLAGS) \
-	-imacros $(CONFIG_HEADER) \
-	-D_HELENOS_SOURCE \
-	-fexec-charset=UTF-8 \
-	-finput-charset=UTF-8 \
-	-fno-common \
-	-fdebug-prefix-map=$(realpath $(ROOT_PATH))=.
-
-# TODO: Use a different name.
-# CFLAGS variable is traditionally used for overridable flags.
-CFLAGS = $(COMMON_CFLAGS) $(HELENOS_CFLAGS) $(DEFAULT_CFLAGS)
+	GCC_CFLAGS += -ggdb
+	CLANG_CFLAGS += -g
+endif
 
 ## Setup platform configuration
@@ -242,4 +216,10 @@
 endif
 
+ifeq ($(COMPILER),clang)
+	CFLAGS += $(COMMON_CFLAGS) $(CLANG_CFLAGS)
+else
+	CFLAGS += $(COMMON_CFLAGS) $(GCC_CFLAGS)
+endif
+
 ifeq ($(CONFIG_STRIP_BINARIES),y)
 	LFLAGS += --strip-all
@@ -266,5 +246,6 @@
 all-test: $(TEST_OUTPUTS)
 
-clean: fasterclean
+clean:
+	rm -f $(JOB) $(OUTPUTS) $(EXTRA_CLEAN) tag deps.mk
 	find . -name '*.o' -follow -exec rm \{\} \;
 	find . -name '*.lo' -follow -exec rm \{\} \;
@@ -272,5 +253,5 @@
 
 fasterclean:
-	rm -rf $(JOB) $(OUTPUTS) $(EXTRA_CLEAN) tag deps.mk
+	rm -f $(JOB) $(OUTPUTS) $(EXTRA_CLEAN) tag deps.mk
 
 depend: $(PRE_DEPEND)
Index: uspace/app/barber/barber.c
===================================================================
--- uspace/app/barber/barber.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/barber/barber.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -208,5 +208,5 @@
 {
 	category_id_t led_cat;
-	errno_t rc = loc_category_get_id("led", &led_cat, IPC_FLAG_BLOCKING);
+	int rc = loc_category_get_id("led", &led_cat, IPC_FLAG_BLOCKING);
 	if (rc != EOK)
 		return;
@@ -255,5 +255,5 @@
 	
 	list_initialize(&led_devs);
-	errno_t rc = loc_register_cat_change_cb(loc_callback);
+	int rc = loc_register_cat_change_cb(loc_callback);
 	if (rc != EOK) {
 		printf("Unable to register callback for device discovery.\n");
Index: uspace/app/bdsh/cmds/builtins/batch/batch.c
===================================================================
--- uspace/app/bdsh/cmds/builtins/batch/batch.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/cmds/builtins/batch/batch.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -32,5 +32,4 @@
 #include <stddef.h>
 #include <errno.h>
-#include <str.h>
 #include "config.h"
 #include "util.h"
@@ -86,5 +85,5 @@
 	}
 
-	errno_t rc = EOK;
+	int rc = 0;
 	FILE *batch = fopen(argv[1], "r");
 	if (batch == NULL) {
@@ -105,5 +104,5 @@
 				if (cur == fusr.line) {
 					/* skip empty line */
-					rc = EOK;
+					rc = 0;
 					free(cur);
 				} else {
Index: uspace/app/bdsh/cmds/builtins/cd/cd.c
===================================================================
--- uspace/app/bdsh/cmds/builtins/cd/cd.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/cmds/builtins/cd/cd.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -51,8 +51,8 @@
 static bool previous_directory_set = false;
 
-static errno_t chdir_and_remember(const char *new_dir)
+static int chdir_and_remember(const char *new_dir)
 {
 
-	errno_t rc = vfs_cwd_get(previous_directory_tmp, PATH_MAX);
+	int rc = vfs_cwd_get(previous_directory_tmp, PATH_MAX);
 	previous_directory_valid = (rc == EOK);
 	previous_directory_set = true;
@@ -85,6 +85,5 @@
 int cmd_cd(char **argv, cliuser_t *usr)
 {
-	int argc;
-	errno_t rc = EOK;
+	int argc, rc = 0;
 
 	argc = cli_count_args(argv);
Index: uspace/app/bdsh/cmds/mknewcmd
===================================================================
--- uspace/app/bdsh/cmds/mknewcmd	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/cmds/mknewcmd	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -1,6 +1,4 @@
 #!/bin/sh
-# Copyright (C) 2008 Tim Post
-# All Rights Reserved
-#
+# Copyright (C) 2008 Tim Post - All Rights Reserved
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are met:
Index: uspace/app/bdsh/cmds/modules/cat/cat.c
===================================================================
--- uspace/app/bdsh/cmds/modules/cat/cat.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/cmds/modules/cat/cat.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -187,5 +187,5 @@
 	off64_t file_size = 0, length = 0;
 	aoff64_t pos = 0;
-	errno_t rc;
+	int rc;
 
 	bool reading_stdin = dash_represents_stdin && (str_cmp(fname, "-") == 0);
@@ -195,10 +195,6 @@
 		/* Allow storing the whole UTF-8 character. */
 		blen = STR_BOUNDS(1);
-	} else {
-		errno_t rc = vfs_lookup_open(fname, WALK_REGULAR, MODE_READ, &fd);
-		if (rc != EOK) {
-			fd = -1;
-		}
-	}
+	} else
+		fd = vfs_lookup_open(fname, WALK_REGULAR, MODE_READ);
 	
 	if (fd < 0) {
@@ -215,5 +211,5 @@
 
 	if (tail != CAT_FULL_FILE) {
-		vfs_stat_t st;
+		struct stat st;
 
 		if (vfs_stat(fd, &st) != EOK) {
@@ -316,5 +312,5 @@
 	bool tailFirst = false;
 	sysarg_t rows, cols;
-	errno_t rc;
+	int rc;
 	
 	/*
@@ -328,5 +324,4 @@
 	console_rows = 0;
 	should_quit = false;
-	dash_represents_stdin = false;
 	console = console_init(stdin, stdout);
 	number = false;
@@ -339,5 +334,5 @@
 
 	for (c = 0, optreset = 1, optind = 0, opt_ind = 0; c != -1;) {
-		c = getopt_long(argc, argv, "xhvmH:t:b:sn", long_options, &opt_ind);
+		c = getopt_long(argc, argv, "xhvmH:t:b:s:n", long_options, &opt_ind);
 		switch (c) {
 		case 'h':
Index: uspace/app/bdsh/cmds/modules/cmp/cmp.c
===================================================================
--- uspace/app/bdsh/cmds/modules/cmp/cmp.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/cmds/modules/cmp/cmp.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -70,7 +70,7 @@
 }
 
-static errno_t cmp_files(const char *fn0, const char *fn1)
+static int cmp_files(const char *fn0, const char *fn1)
 {
-	errno_t rc = EOK;
+	int rc = EOK;
 	const char *fn[2] = {fn0, fn1};
 	int fd[2] = {-1, -1};
@@ -80,6 +80,7 @@
 
 	for (int i = 0; i < 2; i++) {
-		rc = vfs_lookup_open(fn[i], WALK_REGULAR, MODE_READ, &(fd[i]));
-		if (rc != EOK) {
+		fd[i] = vfs_lookup_open(fn[i], WALK_REGULAR, MODE_READ);
+		if (fd[i] < 0) {
+			rc = fd[i];
 			printf("Unable to open %s\n", fn[i]);
 			goto end;
@@ -101,5 +102,5 @@
 		    memcmp(buffer[0], buffer[1], offset[0]) != 0) {
 			printf("Return 1\n");
-			rc = EBUSY;
+			rc = 1;
 			goto end;
 		}
@@ -117,5 +118,5 @@
 int cmd_cmp(char **argv)
 {
-	errno_t rc;
+	int rc;
 	unsigned int argc;
 	int c, opt_ind;
Index: uspace/app/bdsh/cmds/modules/cp/cp.c
===================================================================
--- uspace/app/bdsh/cmds/modules/cp/cp.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/cmds/modules/cp/cp.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -28,5 +28,4 @@
 
 #include <errno.h>
-#include <str_error.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -80,7 +79,7 @@
 static dentry_type_t get_type(const char *path)
 {
-	vfs_stat_t s;
-
-	errno_t r = vfs_stat_path(path, &s);
+	struct stat s;
+
+	int r = vfs_stat_path(path, &s);
 
 	if (r != EOK)
@@ -176,8 +175,8 @@
 }
 
-static errno_t do_copy(const char *src, const char *dest,
+static int do_copy(const char *src, const char *dest,
     size_t blen, int vb, int recursive, int force, int interactive)
 {
-	errno_t rc = EOK;
+	int rc = EOK;
 	char dest_path[PATH_MAX];
 	char src_path[PATH_MAX];
@@ -266,7 +265,5 @@
 
 		/* call copy_file and exit */
-		if (copy_file(src, dest_path, blen, vb) < 0) {
-			rc = EIO;
-		}
+		rc = (copy_file(src, dest_path, blen, vb) < 0);
 
 	} else if (src_type == TYPE_DIR) {
@@ -340,6 +337,6 @@
 		 */
 		while ((dp = readdir(dir))) {
-			vfs_stat_t src_s;
-			vfs_stat_t dest_s;
+			struct stat src_s;
+			struct stat dest_s;
 
 			char src_dent[PATH_MAX];
@@ -388,21 +385,21 @@
 	int fd1, fd2;
 	size_t rbytes, wbytes;
-	errno_t rc;
+	int rc;
 	off64_t total;
 	char *buff = NULL;
 	aoff64_t posr = 0, posw = 0;
-	vfs_stat_t st;
+	struct stat st;
 
 	if (vb)
 		printf("Copying %s to %s\n", src, dest);
 
-	rc = vfs_lookup_open(src, WALK_REGULAR, MODE_READ, &fd1);
-	if (rc != EOK) {
+	fd1 = vfs_lookup_open(src, WALK_REGULAR, MODE_READ);
+	if (fd1 < 0) {
 		printf("Unable to open source file %s\n", src);
 		return -1;
 	}
 
-	rc = vfs_lookup_open(dest, WALK_REGULAR | WALK_MAY_CREATE, MODE_WRITE, &fd2);
-	if (rc != EOK) {
+	fd2 = vfs_lookup_open(dest, WALK_REGULAR | WALK_MAY_CREATE, MODE_WRITE);
+	if (fd2 < 0) {
 		printf("Unable to open destination file %s\n", dest);
 		vfs_put(fd1);
@@ -435,6 +432,6 @@
 
 	if (rc != EOK) {
-		printf("\nError copying %s: %s\n", src, str_error(rc));
-		return -1;
+		printf("\nError copying %s, (%d)\n", src, rc);
+		return rc;
 	}
 
@@ -444,9 +441,5 @@
 	if (buff)
 		free(buff);
-	if (rc != EOK) {
-		return -1;
-	} else {
-		return 0;
-	}
+	return rc;
 }
 
@@ -479,5 +472,5 @@
 	int force = 0, interactive = 0;
 	int c, opt_ind;
-	errno_t ret;
+	int64_t ret;
 
 	con = console_init(stdin, stdout);
Index: uspace/app/bdsh/cmds/modules/ls/ls.c
===================================================================
--- uspace/app/bdsh/cmds/modules/ls/ls.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/cmds/modules/ls/ls.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -32,5 +32,4 @@
 
 #include <errno.h>
-#include <str_error.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -135,5 +134,5 @@
 	int i;
 	int nbdirs = 0;
-	errno_t rc;
+	int rc;
 	int len;
 	char *buff;
@@ -185,5 +184,5 @@
 		if (rc != EOK) {
 			printf("ls: skipping bogus node %s\n", buff);
-			printf("error=%s\n", str_error_name(rc));
+			printf("error=%d\n", rc);
 			goto out;
 		}
Index: uspace/app/bdsh/cmds/modules/ls/ls.h
===================================================================
--- uspace/app/bdsh/cmds/modules/ls/ls.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/cmds/modules/ls/ls.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -23,5 +23,5 @@
 struct dir_elem_t {
 	char *name;
-	vfs_stat_t s;
+	struct stat s;
 };
 
Index: uspace/app/bdsh/cmds/modules/mkdir/mkdir.c
===================================================================
--- uspace/app/bdsh/cmds/modules/mkdir/mkdir.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/cmds/modules/mkdir/mkdir.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -94,11 +94,10 @@
 
 	int ret = 0;
-	errno_t rc;
 
 	if (!create_parents) {
-		rc = vfs_link_path(path, KIND_DIRECTORY, NULL);
-		if (rc != EOK) {
+		ret = vfs_link_path(path, KIND_DIRECTORY, NULL);
+		if (ret != EOK) {
 			cli_error(CL_EFAIL, "%s: could not create %s (%s)",
-			    cmdname, path, str_error(rc));
+			    cmdname, path, str_error(ret));
 			ret = 1;
 		}
@@ -136,8 +135,8 @@
 			path[prev_off] = 0;
 
-			rc = vfs_link_path(path, KIND_DIRECTORY, NULL);
-			if (rc != EOK && rc != EEXIST) {
+			ret = vfs_link_path(path, KIND_DIRECTORY, NULL);
+			if (ret != EOK && ret != EEXIST) {
 				cli_error(CL_EFAIL, "%s: could not create %s (%s)",
-				    cmdname, path, str_error(rc));
+				    cmdname, path, str_error(ret));
 				ret = 1;
 				goto leave;
@@ -147,8 +146,8 @@
 		}
 		/* Create the final directory. */
-		rc = vfs_link_path(path, KIND_DIRECTORY, NULL);
-		if (rc != EOK) {
+		ret = vfs_link_path(path, KIND_DIRECTORY, NULL);
+		if (ret != EOK) {
 			cli_error(CL_EFAIL, "%s: could not create %s (%s)",
-			    cmdname, path, str_error(rc));
+			    cmdname, path, str_error(ret));
 			ret = 1;
 		}
Index: uspace/app/bdsh/cmds/modules/mkfile/mkfile.c
===================================================================
--- uspace/app/bdsh/cmds/modules/mkfile/mkfile.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/cmds/modules/mkfile/mkfile.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -87,7 +87,7 @@
  * @param str	String containing the size specification.
  * @param rsize	Place to store size in bytes
- * @return	EOK on success or an error code
+ * @return	EOK on success or error code
  */
-static errno_t read_size(const char *str, size_t *rsize)
+static int read_size(const char *str, size_t *rsize)
 {
 	size_t number, unit;
@@ -123,5 +123,5 @@
 	size_t to_write;
 	size_t nwritten;
-	errno_t rc;
+	int rc;
 	char *file_name;
 	void *buffer;
@@ -163,6 +163,6 @@
 	file_name = argv[optind];
 
-	rc = vfs_lookup_open(file_name, WALK_REGULAR | WALK_MUST_CREATE, MODE_WRITE, &fd);
-	if (rc != EOK) {
+	fd = vfs_lookup_open(file_name, WALK_REGULAR | WALK_MUST_CREATE, MODE_WRITE);
+	if (fd < 0) {
 		printf("%s: failed to create file %s.\n", cmdname, file_name);
 		return CMD_FAILURE;
@@ -192,5 +192,5 @@
 		rc = vfs_write(fd, &pos, buffer, to_write, &nwritten);
 		if (rc != EOK) {
-			printf("%s: Error writing file (%s).\n", cmdname, str_error(rc));
+			printf("%s: Error writing file (%s).\n", cmdname, str_error(errno));
 			vfs_put(fd);
 			free(buffer);
@@ -202,11 +202,10 @@
 	free(buffer);
 
-	rc = vfs_put(fd);
-	if (rc != EOK)
+	if (vfs_put(fd) < 0)
 		goto error;
 
 	return CMD_SUCCESS;
 error:
-	printf("%s: Error writing file (%s).\n", cmdname, str_error(rc));
+	printf("%s: Error writing file (%s).\n", cmdname, str_error(errno));
 	return CMD_FAILURE;
 }
Index: uspace/app/bdsh/cmds/modules/mount/mount.c
===================================================================
--- uspace/app/bdsh/cmds/modules/mount/mount.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/cmds/modules/mount/mount.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,5 +37,4 @@
 #include <getopt.h>
 #include <inttypes.h>
-#include <str.h>
 #include "config.h"
 #include "util.h"
@@ -79,5 +78,5 @@
 	mtab_ent_t *old_ent = NULL;
 	char *svc_name;
-	errno_t rc;
+	int rc;
 
 	vfs_get_mtab_list(&mtab_list);
@@ -110,5 +109,5 @@
 static void print_fstypes(void)
 {
-	errno_t rc;
+	int rc;
 	vfs_fstypes_t fstypes;
 	char **p;
@@ -133,6 +132,5 @@
 	const char *mopts = "";
 	const char *dev = "";
-	errno_t rc;
-	int c, opt_ind;
+	int rc, c, opt_ind;
 	unsigned int instance = 0;
 	bool instance_set = false;
Index: uspace/app/bdsh/cmds/modules/mv/mv.c
===================================================================
--- uspace/app/bdsh/cmds/modules/mv/mv.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/cmds/modules/mv/mv.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -30,5 +30,4 @@
 #include <stdlib.h>
 #include <errno.h>
-#include <str_error.h>
 #include <vfs/vfs.h>
 #include "config.h"
@@ -52,5 +51,5 @@
 {
 	unsigned int argc;
-	errno_t rc;
+	int rc;
 
 	argc = cli_count_args(argv);
@@ -63,6 +62,6 @@
 	rc = vfs_rename_path(argv[1], argv[2]);
 	if (rc != EOK) {
-		printf("Unable to rename %s to %s: %s)\n",
-		    argv[1], argv[2], str_error(rc));
+		printf("Unable to rename %s to %s (error=%d)\n",
+		    argv[1], argv[2], rc);
 		return CMD_FAILURE;
 	}
Index: uspace/app/bdsh/cmds/modules/rm/rm.c
===================================================================
--- uspace/app/bdsh/cmds/modules/rm/rm.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/cmds/modules/rm/rm.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -149,5 +149,6 @@
 	}
 
-	if (vfs_lookup(path, WALK_REGULAR, &fd) == EOK) {
+	fd = vfs_lookup(path, WALK_REGULAR);
+	if (fd >= 0) {
 		vfs_put(fd);
 		return RM_FILE;
@@ -195,5 +196,5 @@
 static unsigned int rm_recursive(const char *path)
 {
-	errno_t rc;
+	int rc;
 	unsigned int ret = 0;
 
@@ -209,5 +210,5 @@
 	rc = vfs_unlink_path(path);
 	if (rc == EOK)
-		return 0;
+		return EOK;
 
 	cli_error(CL_ENOTSUP, "Can not remove %s", path);
Index: uspace/app/bdsh/cmds/modules/sleep/sleep.c
===================================================================
--- uspace/app/bdsh/cmds/modules/sleep/sleep.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/cmds/modules/sleep/sleep.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -31,5 +31,4 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <str.h>
 #include "config.h"
 #include "util.h"
@@ -63,7 +62,7 @@
  * @return EOK if conversion was successful.
  */
-static errno_t decimal_to_useconds(const char *nptr, useconds_t *result)
+static int decimal_to_useconds(const char *nptr, useconds_t *result)
 {
-	errno_t ret;
+	int ret;
 	uint64_t whole_seconds;
 	uint64_t frac_seconds;
@@ -113,5 +112,5 @@
 int cmd_sleep(char **argv)
 {
-	errno_t ret;
+	int ret;
 	unsigned int argc;
 	useconds_t duration = 0;
Index: uspace/app/bdsh/cmds/modules/touch/touch.c
===================================================================
--- uspace/app/bdsh/cmds/modules/touch/touch.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/cmds/modules/touch/touch.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -82,5 +82,5 @@
 	int longind;
 	bool no_create = false;
-	vfs_stat_t file_stat;
+	struct stat file_stat;
 	int fd = -1;
 	char *buff = NULL;
@@ -123,8 +123,5 @@
 		if ((!no_create) ||
 		    ((no_create) && (vfs_stat_path(buff, &file_stat) == EOK))) {
-			errno_t rc = vfs_lookup(buff, WALK_REGULAR | WALK_MAY_CREATE, &fd);
-			if (rc != EOK) {
-				fd = -1;
-			}
+			fd = vfs_lookup(buff, WALK_REGULAR | WALK_MAY_CREATE);
 		}
 		
Index: uspace/app/bdsh/cmds/modules/unmount/unmount.c
===================================================================
--- uspace/app/bdsh/cmds/modules/unmount/unmount.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/cmds/modules/unmount/unmount.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -31,5 +31,4 @@
 #include <vfs/vfs.h>
 #include <errno.h>
-#include <str_error.h>
 #include "config.h"
 #include "util.h"
@@ -57,5 +56,5 @@
 {
 	unsigned int argc;
-	errno_t rc;
+	int rc;
 
 	argc = cli_count_args(argv);
@@ -69,5 +68,5 @@
 	rc = vfs_unmount_path(argv[1]);
 	if (rc != EOK) {
-		printf("Unable to unmount %s: %s\n", argv[1], str_error(rc));
+		printf("Unable to unmount %s (rc=%d)\n", argv[1], rc);
 		return CMD_FAILURE;
 	}
Index: uspace/app/bdsh/compl.c
===================================================================
--- uspace/app/bdsh/compl.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/compl.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -34,5 +34,4 @@
 #include <stdlib.h>
 #include <vfs/vfs.h>
-#include <str.h>
 
 #include "cmds/cmds.h"
@@ -41,6 +40,6 @@
 #include "tok.h"
 
-static errno_t compl_init(wchar_t *text, size_t pos, size_t *cstart, void **state);
-static errno_t compl_get_next(void *state, char **compl);
+static int compl_init(wchar_t *text, size_t pos, size_t *cstart, void **state);
+static int compl_get_next(void *state, char **compl);
 static void compl_fini(void *state);
 
@@ -69,7 +68,7 @@
 
 	/** Pointer inside list of directories */
-	const char *const *path;
+	const char **path;
 	/** If not @c NULL, should be freed in the end. */
-	char **path_list;
+	const char **path_list;
 	/** Current open directory */
 	DIR *dir;
@@ -88,5 +87,5 @@
  * Set up iterators in completion object, based on current token.
  */
-static errno_t compl_init(wchar_t *text, size_t pos, size_t *cstart, void **state)
+static int compl_init(wchar_t *text, size_t pos, size_t *cstart, void **state)
 {
 	compl_t *cs = NULL;
@@ -94,5 +93,5 @@
 	char *prefix = NULL;
 	char *dirname = NULL;
-	errno_t retval;
+	int retval;
 	
 	token_t *tokens = calloc(WORD_MAX, sizeof(token_t));
@@ -219,7 +218,5 @@
 		cs->path_list[0] = dirname;
 		cs->path_list[1] = NULL;
-		/* The second const ensures that we can't assign a const
-		 * string to the non-const array. */
-		cs->path = (const char *const *) cs->path_list;
+		cs->path = cs->path_list;
 
 	} else if (cs->is_command) {
@@ -291,5 +288,5 @@
 
 /** Get next match. */
-static errno_t compl_get_next(void *state, char **compl)
+static int compl_get_next(void *state, char **compl)
 {
 	compl_t *cs = (compl_t *) state;
@@ -362,5 +359,5 @@
 				char *ent_path;
 				asprintf(&ent_path, "%s/%s", *cs->path, dent->d_name);
-				vfs_stat_t ent_stat;
+				struct stat ent_stat;
 				if (vfs_stat_path(ent_path, &ent_stat) != EOK) {
 					/* Error */
Index: uspace/app/bdsh/errors.h
===================================================================
--- uspace/app/bdsh/errors.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/errors.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,5 +49,5 @@
 
 extern void cli_error(int, const char *, ...)
-    _HELENOS_PRINTF_ATTRIBUTE(2, 3);
+    PRINTF_ATTRIBUTE(2, 3);
 
 #endif
Index: uspace/app/bdsh/exec.c
===================================================================
--- uspace/app/bdsh/exec.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/exec.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -58,6 +58,6 @@
 	int fd;
 
-	errno_t rc = vfs_lookup_open(f, WALK_REGULAR, MODE_READ, &fd);
-	if (rc == EOK) {
+	fd = vfs_lookup_open(f, WALK_REGULAR, MODE_READ);
+	if (fd >= 0) {
 		vfs_put(fd);
 		return 0;
@@ -98,6 +98,5 @@
 	task_exit_t texit;
 	char *tmp;
-	errno_t rc;
-	int retval, i;
+	int rc, retval, i;
 	int file_handles[3] = { -1, -1, -1 };
 	FILE *files[3];
@@ -118,5 +117,5 @@
 	free(tmp);
 
-	if (rc != EOK) {
+	if (rc != 0) {
 		cli_error(CL_EEXEC, "%s: Cannot spawn `%s' (%s)", progname, cmd,
 		    str_error(rc));
Index: uspace/app/bdsh/input.c
===================================================================
--- uspace/app/bdsh/input.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/input.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -65,5 +65,5 @@
  * invokes the built-in entry point (a[0]) passing all arguments in a[] to
  * the handler */
-errno_t process_input(cliuser_t *usr)
+int process_input(cliuser_t *usr)
 {
 	token_t *tokens_buf = calloc(WORD_MAX, sizeof(token_t));
@@ -73,5 +73,5 @@
 	
 	char *cmd[WORD_MAX];
-	errno_t rc = EOK;
+	int rc = 0;
 	tokenizer_t tok;
 	unsigned int i, pipe_count, processed_pipes;
@@ -82,5 +82,5 @@
 	if (usr->line == NULL) {
 		free(tokens_buf);
-		return EINVAL;
+		return CL_EFAIL;
 	}
 
@@ -198,9 +198,5 @@
 	}
 
-	if (run_command(cmd, usr, &new_iostate) == 0) {
-		rc = EOK;
-	} else {
-		rc = EINVAL;
-	}
+	rc = run_command(cmd, usr, &new_iostate);
 	
 finit_with_files:
@@ -259,5 +255,5 @@
 {
 	char *str;
-	errno_t rc;
+	int rc;
 	
 	tinput_set_prompt(tinput, usr->prompt);
Index: uspace/app/bdsh/input.h
===================================================================
--- uspace/app/bdsh/input.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/input.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -35,5 +35,5 @@
 
 extern void get_input(cliuser_t *);
-extern errno_t process_input(cliuser_t *);
+extern int process_input(cliuser_t *);
 extern int input_init(void);
 
Index: uspace/app/bdsh/scli.c
===================================================================
--- uspace/app/bdsh/scli.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/scli.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -98,5 +98,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t ret = 0;
+	int ret = 0;
 	
 	stdiostate.stdin = stdin;
Index: uspace/app/bdsh/scli.h
===================================================================
--- uspace/app/bdsh/scli.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/scli.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,5 +39,5 @@
 	char *cwd;
 	char *prompt;
-	errno_t lasterr;
+	int lasterr;
 } cliuser_t;
 
Index: uspace/app/bdsh/test/toktest.c
===================================================================
--- uspace/app/bdsh/test/toktest.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/test/toktest.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -46,10 +46,10 @@
 	str_cpy(input_buffer, MAX_INPUT, input);
 
-	errno_t rc = tok_init(&tokenizer, input_buffer, tokens, MAX_TOKENS);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	int rc = tok_init(&tokenizer, input_buffer, tokens, MAX_TOKENS);
+	PCUT_ASSERT_INT_EQUALS(EOK, rc);
 
 	size_t token_count;
 	rc = tok_tokenize(&tokenizer, &token_count);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_INT_EQUALS(EOK, rc);
 
 
Index: uspace/app/bdsh/tok.c
===================================================================
--- uspace/app/bdsh/tok.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/tok.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,8 +38,8 @@
 static wchar_t tok_get_char(tokenizer_t *);
 static wchar_t tok_look_char(tokenizer_t *);
-static errno_t tok_push_char(tokenizer_t *, wchar_t);
-static errno_t tok_push_token(tokenizer_t *);
+static int tok_push_char(tokenizer_t *, wchar_t);
+static int tok_push_token(tokenizer_t *);
 static bool tok_pending_chars(tokenizer_t *);
-static errno_t tok_finish_string(tokenizer_t *);
+static int tok_finish_string(tokenizer_t *);
 static void tok_start_token(tokenizer_t *, token_type_t);
 
@@ -51,5 +51,5 @@
  * @param max_tokens number of elements of the out_tokens array
  */
-errno_t tok_init(tokenizer_t *tok, char *input, token_t *out_tokens,
+int tok_init(tokenizer_t *tok, char *input, token_t *out_tokens,
     size_t max_tokens)
 {	
@@ -89,7 +89,7 @@
 
 /** Tokenize the input string into the tokens */
-errno_t tok_tokenize(tokenizer_t *tok, size_t *tokens_length)
-{
-	errno_t rc;
+int tok_tokenize(tokenizer_t *tok, size_t *tokens_length)
+{
+	int rc;
 	wchar_t next_char;
 	
@@ -178,7 +178,7 @@
 
 /** Finish tokenizing an opened string */
-errno_t tok_finish_string(tokenizer_t *tok)
-{
-	errno_t rc;
+int tok_finish_string(tokenizer_t *tok)
+{
+	int rc;
 	wchar_t next_char;
 	
@@ -233,5 +233,5 @@
 
 /** Append a char to the end of the current token */
-errno_t tok_push_char(tokenizer_t *tok, wchar_t ch)
+int tok_push_char(tokenizer_t *tok, wchar_t ch)
 {
 	return chr_encode(ch, tok->outbuf, &tok->outbuf_offset, tok->outbuf_size);
@@ -244,5 +244,5 @@
 
 /** Push the current token to the output array */
-errno_t tok_push_token(tokenizer_t *tok)
+int tok_push_token(tokenizer_t *tok)
 {
 	if (tok->outtok_offset >= tok->outtok_size) {
Index: uspace/app/bdsh/tok.h
===================================================================
--- uspace/app/bdsh/tok.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bdsh/tok.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,5 +42,5 @@
 	size_t byte_length;
 	size_t char_length;
-	token_type_t type;
+ 	token_type_t type;
 } token_t;
 
@@ -63,7 +63,7 @@
 } tokenizer_t;
 
-extern errno_t tok_init(tokenizer_t *, char *, token_t *, size_t);
+extern int tok_init(tokenizer_t *, char *, token_t *, size_t);
 extern void tok_fini(tokenizer_t *);
-extern errno_t tok_tokenize(tokenizer_t *, size_t *);
+extern int tok_tokenize(tokenizer_t *, size_t *);
 
 #endif
Index: uspace/app/bithenge/test.c
===================================================================
--- uspace/app/bithenge/test.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bithenge/test.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -57,5 +57,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 	if (argc < 3) {
 		fprintf(stderr, "Usage: %s <script> <source>\n", argv[0]);
Index: uspace/app/blkdump/blkdump.c
===================================================================
--- uspace/app/blkdump/blkdump.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/blkdump/blkdump.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,5 +49,4 @@
 #include <inttypes.h>
 #include <errno.h>
-#include <str.h>
 
 #define NAME	"blkdump"
@@ -64,5 +63,5 @@
 {
 
-	errno_t rc;
+	int rc;
 	char *dev_path;
 	size_t block_size;
@@ -162,13 +161,12 @@
 	printf("Device %s has %" PRIuOFF64 " blocks, %" PRIuOFF64 " bytes each\n", dev_path, dev_nblocks, (aoff64_t) block_size);
 
-	int ret;
 	if (toc)
-		ret = print_toc();
+		rc = print_toc();
 	else
-		ret = print_blocks(block_offset, block_count, block_size);
+		rc = print_blocks(block_offset, block_count, block_size);
 
 	block_fini(service_id);
 
-	return ret;
+	return rc;
 }
 
@@ -179,5 +177,5 @@
 	aoff64_t limit;
 	size_t data_offset;
-	errno_t rc;
+	int rc;
 
 	data = malloc(block_size);
@@ -218,5 +216,5 @@
 {
 	scsi_toc_multisess_data_t toc;
-	errno_t rc;
+	int rc;
 
 	rc = block_read_toc(service_id, 0, &toc, sizeof(toc));
